--#1 NLL FELADAT: 'A'-val kezd?d? nev? szerz?k szletsi ve
use pubs_access
select [Year Born]
from Authors where Author like 'A%'

--#2 NLL FELADAT: a legrgebbi kiadsi dtum
select min([Year Published])
from Titles 

--#3 NLL FELADAT: a legrgebben kiadott knyv cme
--update Titles set [Year Published]=1993 where [Year Published]=0

select title
from Titles
where [Year Published] = (select min([Year Published]) from Titles)

--#4 NLL FELADAT: 1991-ben kiadott knyvek kiadi
select [Company Name]
from Publishers p inner join Titles t on p.PubID=t.PubID
where t.[Year Published]=1991

--#5 NLL FELADAT: 1997 el?tt intzett rendelsek gynkei (Lastname)
use northwind
select lastname, *
from orders o inner join employees e on o.EmployeeID=e.EmployeeID
where o.OrderDate<'1998-01-01'

--#6 NLL FELADAT: Fuller nev? zletkt? ltal eladott termkek neve (4 tbla)

select p.ProductName
from Products p inner join [Order Details] od on od.ProductID=p.ProductID
inner join Orders o on o.OrderID=od.OrderID 
inner join Employees e on e.EmployeeID=o.EmployeeID
where e.LastName='Fuller'

--#7 NLL FELADAT: melyik termk nem szerepel egy rendelsen sem
select p.ProductName, p.ProductID
from Products p left outer join [Order Details] od on od.ProductID=p.ProductID
where od.ProductID is null

--#8 NLL FELADAT: melyik kiadnak hny knyve jelent meg eddig
use pubs_access
select p.PubID, p.[Company Name], COUNT(isbn) as db
from Publishers p left outer join Titles t on p.PubID=t.PubID
group by p.PubID, p.[Company Name]
order by db desc

--#9 NLL FELADAT: melyik termkkategria (Categories) bonyoltotta le az 1997-es vben a legnagyobb forgalmat? Hny termkkel?
use northwind
select top 1 c.CategoryID, c.CategoryName, count(distinct p.productid) as termekszam, sum((1-discount)*od.unitprice*quantity) as osszeg
from Categories c inner join Products p on c.CategoryID=p.CategoryID
inner join [Order Details] od on od.ProductID=p.ProductID
inner join Orders o on o.OrderID=od.OrderID
where year(o.OrderDate)=1997
group by c.CategoryID, c.CategoryName
order by osszeg desc

--4	Dairy Product	10	115387.63993454

--#10 NLL FELADAT: melyik a legtbb knyvvel rendelkez? kiad?
use pubs_access
select top 1 p.PubID, p.[Company Name], COUNT(isbn) as db
from Publishers p inner join Titles t on t.PubID=p.PubID
group by p.PubID, p.[Company Name]
order by db desc

--715	Prentice Hall Div. of Simon & Schuster, Inc.	542


--#11 NLL FELADAT Melyik gynk adta el a legtbbet a legkeresettebb termkbol s mi az a termk?
use northwind
select top 1 u.titleofcourtesy+' '+u.lastname+' '+ u.firstname +' ('+u.title +')'  as nev,
    sum(quantity) as hanyat_adott_el
    ,pr.productname as mibol
from orders o inner join [order details] d on o.orderid=d.orderid
    inner join employees u on u.employeeid=o.employeeid
    inner join products pr on pr.productid=d.productid
where d.productid =
    (select top 1 p.productid
    from products p left outer join [order details] d on p.productid=d.productid
    group by p.productid, p.productname
    order by count(*) desc)
group by u.employeeid, u.titleofcourtesy, u.title, u.lastname, u.firstname
, pr.ProductID,pr.productname  --ha ltni akarjuk azt is, hogy mi a legkeresettebb termk
        --nem okozhat hibt, mert a where elobb szur, mint a group
order by sum(quantity) desc

--Ms. Leverling Janet (Sales Representative)	393 db.	Boston Crab Meat

--#12 NLL FELADAT A legtermkenyebb szerz? melyik kiadnl publiklt legtbbszr?
use pubs_access
select top 1 a.Au_ID--, COUNT(*)
from Authors a inner join TitleAuthor ta on a.Au_ID=ta.Au_ID
group by a.au_id
order by COUNT(*) desc

select p.[Company Name] as kiado, COUNT(*) as konyvek_szama, au2.Author
from Publishers p inner join Titles t on p.PubID=t.PubID
inner join TitleAuthor ta2 on t.ISBN=ta2.ISBN 
inner join Authors au2 on au2.Au_ID=ta2.Au_ID
where ta2.Au_ID= (
	select top 1 a.Au_ID--, COUNT(*)
	from Authors a inner join TitleAuthor ta on a.Au_ID=ta.Au_ID
	group by a.au_id
	order by COUNT(*) desc
)
group by p.PubID, p.[Company Name], au2.Au_ID, au2.Author
having COUNT(*) > 2
order by konyvek_szama desc

--Prague, Carry 62 knyve kzl 14 jelent meg a TAB BOOKS-nl

--#13 NLL FELADAT: a megjelent knyvek szma kiadnknt s vente 

select p.[Company Name] as ceg, p.PubID, t.[Year Published] as ev, COUNT(isbn) as szam
from Publishers p inner join Titles t on p.PubID=t.PubID
group by p.PubID, p.[Company Name], t.[Year Published]
order by p.PubID --debug cljra

--#14 NLL FELADAT: meyik kiad hny knyvet ad ki vente tlagosan?

use pubs_access
drop table #pp
select p.[Company Name] as ceg, p.PubID, t.[Year Published] as ev, COUNT(isbn) as szam
into #pp
from Publishers p inner join Titles t on p.PubID=t.PubID
group by p.PubID, p.[Company Name], t.[Year Published]
order by p.PubID --debug cljra

select PubID, ceg, AVG(szam) as atlag
from #pp 
group by pubid, ceg
order by atlag desc

--#15 NLL FELADAT: melyik kiad melyik vben adta ki a legtbb knyvt? 

select *
from #pp 
where CAST(pubid as varchar(50))+' '+CAST(szam as varchar(50)) in (  --a ' ' azrt kell, hogy ne alakulhassanak ki ktrtelm? azonostk
	select CAST(pubid as varchar(50))+' '+CAST(max(szam) as varchar(50))
	from #pp
	group by pubid)
	

--#16 NLL FELADAT
--a northwind.employees tblt msoljuk t a sajt adatbzisunkba
--"select ... into" mdszerrrel
--rjunk egy lekrdezst, ami a mez?-orientlt alakbl a rekord-orientlt
--alakot lltja el?,
--az EmployeeID, Lastname, Address, City mezokre (union)!
use ab81
select * into my_emp from northwind.dbo.Employees
create table my_emp_rec (empid integer not null, property_code varchar(50) not null, property_value varchar (200))

use ab81
select employeeid, 1, lastname from my_emp
union all
select employeeid, 2, Address from my_emp
union all
select employeeid, 3, City from my_emp

/***************************************
#17 NLL FELADAT: Melyek azok a f?vrosok, melyek 1000 km sugar krnyezetben nincs hegy?

1) keressk meg azokat a vrosokat, melyeknek 1000 km 
sugar krnyezetben VAN hegy
2) ez alapjn (al-lekrdezssel) keressk meg azokat a vrosokat, melyeknek 1000 km 
sugar krnyezetben NINCS hegy
3) s rajzoljuk ki ezen vrosok krli 
1000km sugar buffer terleteket
4) a foltokba rjuk bele a vros nevt! (select label column: nev
5) sz?ktsk a tallatokat a f?vrosokra (a country tblbl)!

--hetven ilyen f?vros van
********************************************/

select Name as nev, geog.STBuffer(1000000) as buffer 
			--ha nincs alias neve a Name mez?nek, nem teszi ki a cmkt
from city where Name not in (
	select city.Name as varosnev
	from city, mountain
	where city.geog.STDistance(mountain.geog) < 1000000
) and geog is not null
and Name in (select capital from country)

--#18 NLL FELADAT a fenti script alapjn: 
--1. egy j tbla ltrehozsa, 2. 100 vletlen float rtkkel feltltse
--3. listzsa s 4. trlse

declare @i int
if exists (select * from dbo.sysobjects
        where id = object_id('[dbo].[veletlen]')
        and OBJECTPROPERTY(id, 'IsUserTable') = 1)
    drop table [dbo].[veletlen]

create table veletlen (szam float)
set @i=1
while @i<=100 begin
    insert veletlen (szam) values (100*rand())
    set @i=@i+1
end
select * from veletlen
drop table veletlen

/*********************************************************
#19 NLL FELADAT:
Raktrkszlet-karbantart script illetve trolt eljrs

Az eljrst a raktros hasznlja arra, hogy egy
ltezo termk raktrkszlett nvelje, vagy egy j cikket vegyen fel
a raktrba.

bemen? paramterek:
set @termeknev = 'Raclette'
set @mennyiseg = 12
set @szallito = 'Formago Company'

A script '%raclette%'-re illo termknevet keres a Products tblban.
Ha tbb, mint 1 tallat van, hibazenettel kilp.
Ha 1 tallat van, akkor annak a raktrkszlett (unitsinstock) nveli
12-vel.
Ha nincs tallat, akkor felvesz egy j Raclette nevu termket, melynek a
szlltjt (supplier) a 3. paramter alapjn prblja belltani,
a fentihez hasonl logikval (tbb tallat: hiba, 1 tallat: megvan,
0 tallat: j supplier felvtele)

A munkt a sajt adatbzisban vgezzk, eloszr is (ha kell) msoljuk t ide a
kt tblt!

1. lps: olyan lekrdezs, amely visszaadja a mintra illeszkedo rekordok szmt
2. lps: beszr INSERT illetve mdost UPDATE utasts sszeraksa
3. lps: a lekrdezsek begyazsa egy IF felttelt hasznl script-be
4. lps: a script tesztelse 
************************************************************/

select * into products from northwind.dbo.Products
select * into suppliers from northwind.dbo.Suppliers

drop procedure raktar_bovit 
create procedure raktar_bovit
@nev varchar(50),
@mennyiseg int,
@szallitonev varchar(50)
as
set nocount on
declare @talalatok_szama int, @uj_termek_id int, @uj_szallito_id int, @talalat_szallito int
select @talalatok_szama = count(*) from products
        where productName like '%' + @nev + '%'    ;
if @talalatok_szama = 1
    begin
        update products set unitsinstock = unitsinstock + @mennyiseg
            where productName like '%' + @nev + '%'
        print 'Mennyisg mdostva'
    end
else if @talalatok_szama = 0 --j termk
    begin
    --a szllt ellenrzse, felvtele
		select @talalat_szallito=COUNT(*) from suppliers 
			where CompanyName like '%' + @szallitonev + '%'
		if @talalat_szallito = 1
			select @uj_szallito_id=supplierid from suppliers 
				where CompanyName like '%' + @szallitonev + '%'	 
		else if @talalat_szallito = 0 
		begin  --j szllt
			insert suppliers (CompanyName) values (@szallitonev)
			set @uj_szallito_id=@@identity
			print 'j szllt felvve: ' + cast(@uj_szallito_id as varchar(50))
		end else begin
			print 'Tl sok tallat, krem pontostsa a szllt nevt!'
			return
		end
        insert products (productname, unitsinstock, discontinued, SupplierID)
            values(@nev, @mennyiseg, 0, @uj_szallito_id)
        set @uj_termek_id = @@identity
        print 'j termk felvve: ' + cast(@uj_termek_id as varchar(50))
    end
    else if @talalatok_szama <= 10 --vlaszts
    begin
        print 'Tbb tallat, krem, vlasszon a listbl!'
		select * from products where productName like '%' + @nev + '%'    ;
    end else  --pontosts
        print 'Tl sok tallat, krem pontostsa a termknevet!'

--TESZTELS:

raktar_bovit '%', 12, 'x comp'

raktar_bovit 'raclette c', 12, 'x comp'
select * from products where productName like '%raclette c%'

raktar_bovit 'raclette, nagyon j', 12, 'x comp'
select * from products where productName like '%raclette, nagyon j%'

raktar_bovit 'rac', 12, 'x comp'
select * from products where productName like '%raclette, nagyon j%'

raktar_bovit 'raclette, legujabb', 12, 'Gai'
select * from suppliers where CompanyName like '%Gai%'

raktar_bovit 'raclette, legeslegujabb', 12, 'j cgnv'
select * from suppliers where CompanyName like '%j%'
select * from products where productName like '%raclette%'

--#21 NLL FELADAT: kapott nev? vsrl egyenlegnek nvelse 10%-kal
--a Vsrl tblban
--itt mr tnyleg elofordulhat, hogy egy nvre tbb rekord is illik
--eljrs neve: bonus, paramter a vsrlnv varchar(50)











--#22 NLL FELADAT: korbbi vletlen szmos feladatunk megvalstsa trolt eljrsknt

create procedure sp_veletlen
@hany_szam int
as
declare @i int
--if exists: haladknak
if exists (select * from dbo.sysobjects
        where id = object_id('[dbo].[veletlen]')
        and OBJECTPROPERTY(id, 'IsUserTable') = 1)
    drop table [dbo].[veletlen]

create table veletlen (szam float)
set @i=1
while @i<=@hany_szam begin
    insert veletlen (szam) values (100*rand())
    set @i=@i+1
end
select * from veletlen
drop table veletlen

go

exec sp_veletlen 250

--#23 NLL FELADAT: 
--rjunk fggvnyt, amely kt, datetime tpus vltoz kzl
--visszaadja a korbbit, ha valamelyik null, akkor pedig a 'N.A.' stringet!
--tesztels az orders tbln
use ab81
drop function korabbi
create function korabbi (@d1 datetime, @d2 datetime) returns varchar(50) as
begin
	declare @eredm varchar(50)
	if @d1<=@d2 set @eredm=@d1 else if @d2<@d1 set @eredm=@d2 else set @eredm='N.A.'
	return @eredm
end

select diak81.korabbi('1997-02-08','2001-01-30')
select diak81.korabbi('2007-02-08','2001-01-30')
select diak81.korabbi(null,'2001-01-30')


--#24 NLL FELADAT (knny?)
--olyan script, amely az amerikai vsrlk (customers tbla, country mez?) rekordjain 
--vgiglpked s kirja minden vsrl nevt, s hogy eddig hny rendelse volt

declare @custid nchar(5), @custname nvarchar(40), @orders int
declare c cursor for 
	select customerid, companyname
	from customers where country='USA'
open c
fetch next from c into @custid, @custname
while @@FETCH_STATUS = 0 begin
	select @orders=COUNT(orderid) from orders where CustomerID=@custid
	print @custname + ': ' + cast(@orders as varchar(50)) + ' orders'
	fetch next from c into @custid, @custname	
end
close c deallocate c

-- a fenti ciklus egyenrtk? ezzel az sql lekrdezssel:

select companyname + ': ' + cast(COUNT(orderid) as varchar(50)) + ' orders'
from customers c inner join orders o on c.CustomerID=o.CustomerID
where c.country='USA'
group by c.CustomerID, c.CompanyName

--melyik az egyszer?bb?

/*************************************************************
#25 NLL FELADAT (NEHZ)

A feladat annak kidertse, hogy a paramterknt kapott
gynk

1) milyen tlagos gyakorisggal (napokban mrve) kt nagy rtk? rendelst, illetve
2) hnyszor fordult elo vele, hogy kt kis rtk? rendelse kzvetlenl kvette egymst

nagy rtk?nek a 200 dollr feletti rendelsek szmtanak. Teht ha pl. egy gynk
rendelseinek a dtumai az albbiak:

2011. jan. 3. (820 $)
2011. jan. 4. (190 $)
2011. jan. 5. (11,200 $)
2011. jan. 10. (100 $)
2011. jan. 11. (140 $)
2011. jan. 20. (540 $)

akkor
1) 2+15=17 nap alatt 3 nagy rtku rendels, teht az tlag 5.7 nap
2) egyszer fordult elo, hogy egyms utn kt kisrtku rendels jtt

A megolds lpsei:

1. kurzor ksztse az illet gynk rendelsi dtumaira s azok rtkre
(korbbi anyagbl kiollzhat a lekrdezs), rendezs dtum szerint
2. a kurzor vgiglptetse, a rendels tpusnak mentse kt rekord kztt egy vltozba
3. tesztels az Orders tbln

segtsg:
select DATEDIFF(day, '2011-02-23', '2011-03-03') -- az eredmny 11, integer

Tovbbfejleszts (SZORGALMI FELADAT): legyen ez egy trolt eljrsban, s hvjuk meg sorban minden gynkre!
Vagy prbljuk ugyanezt elvgezni kt egymsba gyazott kurzorral (a kls?
az gynkkn lpked vgig, a bels? az illet? rendelsein)

**************************************************************************/
use northwind
declare @empid int 
set @empid=2 --debug: neki tbbszr is van kt kicsi egyms utn
declare @datum date, @elozo_datum date, @osszeg float, @elozo_osszeg float, @ket_kicsi_egymas_utan int
declare @osszes_nap int, @rendelsek_szama int
declare c cursor for 
	select o.orderdate, sum((1-discount)*unitprice*quantity)
	from orders o inner join [order details] d on o.orderid=d.orderid
	where EmployeeID = @empid
	group by o.orderid, o.orderdate
	order by o.orderdate

set @ket_kicsi_egymas_utan = 0
set @osszes_nap = 0
set @rendelsek_szama = 0

open c
fetch next from c into @datum, @osszeg
while @@FETCH_STATUS = 0 begin
	if @elozo_datum is not null  --nem az els rekord
		set @osszes_nap = @osszes_nap + DATEDIFF(DAY, @elozo_datum, @datum)
	if @osszeg >= 200
		set @rendelsek_szama = @rendelsek_szama + 1
	if @osszeg < 200 and @elozo_osszeg < 200 begin
		set @ket_kicsi_egymas_utan = @ket_kicsi_egymas_utan + 1
		--print 'msodik kicsi: ' + cast(@datum as varchar(50))  --debug
	end
	set @elozo_datum = @datum
	set @elozo_osszeg = @osszeg
	fetch next from c into @datum, @osszeg
end
close c deallocate c
--print @rendelsek_szama
--print @osszes_nap
print 'tlagos id kt nagyrtk rendels kztt: ' + cast( @osszes_nap * 1.0 / (@rendelsek_szama * 1.0) as varchar(50))
print 'hnyszor jtt kt kis rtk rendels egyms utn: ' + cast(@ket_kicsi_egymas_utan  as varchar(50))

go

--tesztels:
	select o.orderdate, sum((1-discount)*unitprice*quantity)
	from orders o inner join [order details] d on o.orderid=d.orderid
	where EmployeeID = 2 
	group by o.orderid, o.orderdate
	--having sum((1-discount)*unitprice*quantity) >= 200
	order by  o.orderdate	--85 nagy rtk rendels
	
	select datediff(day, '1996-07-25 00:00:00.000', '1998-05-05 00:00:00.000') --649

--Ez alapjn a @rendelsek_szama s a @osszes_nap rtke j

--A @ket_kicsi_egymas_utan az idsor vgignzsvel s a "msodik kicsi" kiratsval ellenrizhet